unit uoddface_prepare;
interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ComCtrls, ExtCtrls,
  xmatdefs,
  uListadoProblemasODDFACE,
  uDataSetGenerico,
  uconstantessimsee,
  unotificar,
  uversiones_oddface,
  urosx;

type

  { TForm1 }

  TForm1 = class(TForm)
    btNuevo: TButton;
    btRefrescar: TButton;
    Button1: TButton;
    Button2: TButton;
    cb_recordar_clave_proxy: TCheckBox;
    cb_recordar_clave_simsee: TCheckBox;
    eUsuarioSimSEE: TEdit;
    eClaveSimSEE: TEdit;
    eproxy_host: TEdit;
    eproxy_pass: TEdit;
    eproxy_puerto: TEdit;
    eproxy_user: TEdit;
    gb_ProxyParams: TGroupBox;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label15: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    memo_login: TMemo;
    PageControl1: TPageControl;
    Panel1: TPanel;
    Panel2: TPanel;
    ScrollBox1: TScrollBox;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    procedure btCrearTablasDBClick(Sender: TObject);
    procedure btNuevoClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure btRefrescarClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }

  public
    { public declarations }
    lst_problemas: TListadoProblemasODDFACE;
    dbcon: TDBrosxCon;

    procedure LoadConfig;
    procedure SaveConfig;

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }



procedure TForm1.btNuevoClick(Sender: TObject);
var
  nid_problema: integer;
  sql: string;
  str_nombres, str_valores: string;
begin

 nid_problema := TListadoProblemasODDFACE.CrearNuevoProblema( dbcon );

 if lst_problemas <> nil then
 begin
   lst_problemas.flg_populate:= true;
   lst_problemas.Editar_onClick( intToStr( nid_problema ), 0 );
 end;

end;

procedure TForm1.btCrearTablasDBClick(Sender: TObject);
begin

end;


procedure TForm1.loadconfig;
var
  fconfig: textfile;
  version: integer;
  pal: string;
  archi: string;

function getpal: string;
begin
  if not eof( fconfig ) then
  begin
    readln( fconfig, pal );
    result:= desbarullar( pal )
  end
  else
    result:= '';
end;

begin
  archi := getDir_Bin+'oddface.cfg' ;
  if fileexists( archi ) then
  begin
    assignfile( fconfig, archi );
    reset( fconfig );
    readln( fconfig, version ); // versión del archivo
    eUsuarioSimSEE.text:= getpal;
    eClaveSimSEE.text:= getpal;
    eproxy_host.text:= getpal;
    eproxy_puerto.text:= getpal;
    eproxy_user.text:= getpal;
    eproxy_pass.text:= getpal;
    cb_recordar_clave_proxy.checked := getpal = '1';
    cb_recordar_clave_simsee.checked := getpal = '1';
    closefile( fconfig );
  end;
end;


procedure TForm1.saveconfig;
var
  fconfig: textfile;
begin
  assignfile( fconfig, getDir_Bin+'oddface.cfg' );
  rewrite( fconfig );
  writeln( fconfig, 1); // versión del archivo
  writeln( fconfig, barullar( eUsuarioSimSEE.text ));
  if cb_recordar_clave_simsee.Checked then
   writeln( fconfig, barullar( eClaveSimSEE.text ))
  else
   writeln( fconfig, '' );
  {$IFDEF PROXY_ENABLED_ROS}
  writeln( fconfig, barullar(dbcon.proxy_host ));
  writeln( fconfig, barullar(dbcon.proxy_port ));
  writeln( fconfig, barullar(dbcon.proxy_user ));
  if cb_recordar_clave_proxy.Checked then
   writeln( fconfig, barullar(dbcon.proxy_pass ))
  else
   writeln( fconfig, '');
  {$ENDIF}

  if cb_recordar_clave_proxy.checked then
    writeln( fconfig, barullar( '1' ) )
  else
   writeln( fconfig, barullar( '0' ) );

  if cb_recordar_clave_simsee.checked then
    writeln( fconfig, barullar( '1' ) )
  else
   writeln( fconfig, barullar( '0' ) );

  closefile( fconfig );
end;


procedure TForm1.Button1Click(Sender: TObject);
var
  hora: string;
begin
  {$IFDEF PROXY_ENABLED_ROS}
  dbcon.proxy_host:= trim( eproxy_host.text );
  dbcon.proxy_port:= trim( eproxy_puerto.text );
  dbcon.proxy_user:= trim( eproxy_user.text );
  dbcon.proxy_pass:= trim( eproxy_pass.text );
  {$ENDIF}
  unotificar.esperando_inicio('... intentando conexión con servidor de IIE-FING...');
  hora:= dbcon.sql_func( 'SELECT now() FROM ofe_problemas LIMIT 1 ' );
  if hora <> '' then
  begin
    memo_login.Lines.add('Se ha conectado correctamente al servidor del IIE-FING');
    memo_login.lines.add(' .. la hora del servidor es: '+hora );
    saveconfig;
  end
  else
  begin
    memo_login.Lines.add('FALLO INTENTO DE CONEXIÓN' );
  end;
  unotificar.esperando_fin;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  hora: string;
begin
  {$IFDEF PROXY_ENABLED_ROS}
  dbcon.proxy_host:= trim( eproxy_host.text );
  dbcon.proxy_port:= trim( eproxy_puerto.text );
  dbcon.proxy_user:= trim( eproxy_user.text );
  dbcon.proxy_pass:= trim( eproxy_pass.text );
  {$ENDIF}
  dbcon.usuario_email:= trim( eUsuarioSimSEE.text );
  try
    unotificar.esperando_inicio('... Intentando conexión con servidor IIE-FING ....');

    hora:= dbcon.sql_func( 'SELECT now() ' );
    unotificar.esperando_fin;
    if hora <> '' then
    begin
      saveconfig;
      PageControl1.TabIndex:= 0;
      TabSheet1.Enabled:= true;
      TabSheet1.Visible:= true;
      TabSheet2.Enabled:= false;
      TabSheet2.Visible:= false;
      lst_problemas.flg_populate:= true;
    end
    else
      unotificar.notificar( 'No fue posible conectarse al servidor. Si usted está detrás de un PROXY debe configurarlo.', true );
  finally
  end;
end;

procedure TForm1.btRefrescarClick(Sender: TObject);
begin
  if lst_problemas = nil then
  begin
    lst_problemas:= TListadoProblemasODDFACE.Create(dbcon, scrollbox1, 'lst_problemas' );
    lst_problemas.Parent:= scrollbox1;
  end;
  lst_problemas.flg_populate:= true;
  lst_problemas.Invalidate;
  ScrollBox1.AutoScroll:=false;

end;


procedure TForm1.FormCreate(Sender: TObject);
begin

  loadconfig;

  PageControl1.TabIndex:= 1;
  TabSheet1.Enabled:= false;
  TabSheet1.Visible:= false;
  TabSheet2.Enabled:= true;
  tabsheet2.visible:= true;

  dbcon:= TDBrosxCon.Create('', 'iie.fing.edu.uy', 80, '/simsee/ros/rosx.php' );

  lst_problemas:= TListadoProblemasODDFACE.Create(dbcon, scrollbox1, 'lst_problemas' );
  lst_problemas.Parent:= scrollbox1;
  lst_problemas.flg_populate:= false;

  Caption:= 'OddFace - '+uversiones_oddface.vOddFace+' (c) IIE-FING';

  {$IFDEF PROXY_ENABLED_ROS}
  gb_ProxyParams.visible:= true;
  {$ENDIF}
end;


procedure TForm1.Timer1Timer(Sender: TObject);
begin
  lst_problemas.populate;
end;

(**
procedure TForm1.Button3Click(Sender: TObject);
var
  ds: TResultadoQuery;
  r: TDataRecord;
begin
  ds:= sql_query( 'SELECT nid FROM ofe_problemas WHERE tipo = 2' );
  r:= ds.first;
  while r<> nil do
  begin
    sql_exec( 'DELETE FROM ofe_individuos_'+ r.GetByNameAsString('nid')+' WHERE dtu > ''2012-11-10 21:00:00'' ');
    writeln( 'problema : '+ r.GetByNameAsString('nid') );
    r:= ds.next;
  end;
end;
**)

end.


