unit uEstimadorGenERNC;


interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ComCtrls, ExtCtrls, Math, xmatdefs, matreal, matent, uauxiliares,
  types,ufechas,ucurvasaeros,
  Clipbrd,
  EditBtn, Menus,
  {$IFDEF MODELO_PARQUE}
  umodelogenernc,
  {$ENDIF}
  uro_aire, ucomplex,
  ucalibrador,
  uparques_modeloteorico,
  uparques_modeloempirico,
  uparques_modelocombinado,
  uescalacolores,
  {$IFDEF pq_direct}
  udbconpg,
  {$ELSE}
  urosx,
  {$ENDIF}
  ugraficador,
  ucaminos_modelado_ro,
  umodelosintcegh;

type

  { TFormEstimadorGenERNC }

  TFormEstimadorGenERNC = class(TForm)
    btCalcular1: TButton;
    btCalcular3: TButton;
    btCalibrarParque3: TButton;
    btCargarCalibrador3: TButton;
    btCargarMC1: TButton;
    btGuardarCalibrador3: TButton;
    btModeladoParques: TButton;
    btCalibrarParque: TButton;
    btCambiar_ro: TButton;
    btCargarCalibrador: TButton;
    btGuardarCalibrador: TButton;
    btProcesarRestricciones1: TButton;
    btProcesarSeries: TButton;
    btLevantarCurvaAeroADB: TButton;
    btBajarParque: TButton;
    btProcesarSeries3: TButton;
    btProcesarSeriesConMC1: TButton;
    btUpdateMTinDB3: TButton;
    Button1: TButton;
    btProcesarSeriesConMC: TButton;
    btUpdateMTinDB: TButton;
    btCalcularMC: TButton;
    btCargarMC: TButton;
    BorrarSupercentral: TButton;
    CrearSupercentral: TButton;
    btProcesarRestricciones: TButton;
    CalcularReduccion: TButton;
    CalcularReduccion3: TButton;
    cbCambiarTodosLosRo: TCheckBox;
    eAlfaTerreno1: TLabeledEdit;
    eAlfaTerreno3: TLabeledEdit;
    eDir1: TLabeledEdit;
    eDir3: TLabeledEdit;
    eErr2Calibrar3: TLabeledEdit;
    eEthaMeteo2: TLabeledEdit;
    eFactorPerdidasParque1: TLabeledEdit;
    eFactorPerdidasParque3: TLabeledEdit;
    efpv3pe1: TLabeledEdit;
    efpv3pe3: TLabeledEdit;
    eGamma_Atmosfera1: TLabeledEdit;
    eLimiteDePotencia1: TLabeledEdit;
    eME_Peso1: TLabeledEdit;
    eME_Peso3: TLabeledEdit;
    ePE_MW_ModeloTeorico1: TLabeledEdit;
    ePE_MW_ModeloTeorico3: TLabeledEdit;
    ePE_MW_Representantes1: TLabeledEdit;
    ePE_MW_Representantes3: TLabeledEdit;
    eVAnemoEntrada1: TLabeledEdit;
    eVAnemoEntrada3: TLabeledEdit;
    eVAnemoResultante1: TLabeledEdit;
    eVAnemoResultante3: TLabeledEdit;
    FechaDesde: TDateEdit;
    FechaDesde1: TDateEdit;
    FechaHasta: TDateEdit;
    eCoordenadasXY: TEdit;
    eEthaMeteo1: TLabeledEdit;
    eMolino: TEdit;
    eFactorPerdidasParque: TLabeledEdit;
    eLimiteDePotencia: TLabeledEdit;
    eGamma_Atmosfera: TLabeledEdit;
    efpv3pe: TLabeledEdit;
    ePE_MW_Representantes: TLabeledEdit;
    eEthaMeteo: TLabeledEdit;
    eME_Peso: TLabeledEdit;
    FechaHasta1: TDateEdit;
    GroupBox1: TGroupBox;
    eDir: TLabeledEdit;
    eVAnemoEntrada: TLabeledEdit;
    eVAnemoResultante: TLabeledEdit;
    btCalcular: TButton;
    eAlfaTerreno: TLabeledEdit;
    eErr2Calibrar: TLabeledEdit;
    ePE_MW_ModeloTeorico: TLabeledEdit;
    eEthaMolino: TLabeledEdit;
    barracolores_imglst: TImageList;
    eNidCentral: TLabeledEdit;
    GroupBox2: TGroupBox;
    GroupBox4: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    NIDsupercentralBorrar: TLabeledEdit;
    NIDcentralAnemo: TLabeledEdit;
    NIDcentralesAunir: TLabeledEdit;
    odCalibrador: TOpenDialog;
    OpenDialog1: TOpenDialog;
    odProcesarSeries: TOpenDialog;
    PageControl1: TPageControl;
    PaintBox1: TPaintBox;
    pb_Parque_original: TPaintBox;
    pb_Parque_simple: TPaintBox;
    Panel1: TPanel;
    sdCalibrador: TSaveDialog;
    Splitter1: TSplitter;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;

    procedure btBajarParqueClick(Sender: TObject);
    procedure btCalcularMCClick(Sender: TObject);
    procedure btCalibrarParqueClick(Sender: TObject);
    procedure btCambiar_roClick(Sender: TObject);
    procedure btCargarCalibradorClick(Sender: TObject);
    procedure btCargarMCClick(Sender: TObject);
    procedure btGuardarCalibradorClick(Sender: TObject);
    procedure btCalcularClick(Sender: TObject);
    procedure btLevantarCurvaAeroADBClick(Sender: TObject);
    procedure btLoadFromArchi_ModeloMTySeriesClick(Sender: TObject);
    procedure btUpdateMTinDBClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure btProcesarSeriesConMCClick(Sender: TObject);
    procedure BorrarSupercentralClick(Sender: TObject);
    procedure CrearSupercentralClick(Sender: TObject);
    procedure btProcesarRestriccionesClick(Sender: TObject);
    procedure CalcularReduccionClick(Sender: TObject);
    procedure eAlfaTerreno1Change(Sender: TObject);
    procedure eDir1Change(Sender: TObject);
    procedure eDirChange(Sender: TObject);
    procedure eEthaMeteo1Change(Sender: TObject);
    procedure eAlfaTerrenoChange(Sender: TObject);
    procedure eFactorPerdidasParqueChange(Sender: TObject);
    procedure efpv3peChange(Sender: TObject);
    procedure eLimiteDePotenciaChange(Sender: TObject);
    procedure eVAnemoEntradaChange(Sender: TObject);
    procedure eEthaMeteo2Change(Sender: TObject);
    procedure eEthaMeteoChange(Sender: TObject);
    procedure eFactorPerdidasParque1Change(Sender: TObject);
    procedure efpv3pe1Change(Sender: TObject);
    procedure eGamma_Atmosfera1Change(Sender: TObject);
    procedure eGamma_AtmosferaChange(Sender: TObject);
    procedure eLimiteDePotencia1Change(Sender: TObject);
    procedure eME_PesoChange(Sender: TObject);
    procedure ePE_MW_ModeloTeoricoChange(Sender: TObject);
    procedure ePE_MW_RepresentantesChange(Sender: TObject);
    procedure eVAnemoEntrada1Change(Sender: TObject);
    procedure eVAnemoResultanteChange(Sender: TObject);
    procedure FechaDesde1Change(Sender: TObject);
    procedure FechaHasta1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);

    procedure FormCreate(Sender: TObject);
    procedure GroupBox2Click(Sender: TObject);
    procedure Label7Click(Sender: TObject);
    procedure NIDcentralAnemoChange(Sender: TObject);
    procedure NIDcentralesAunirChange(Sender: TObject);

    procedure pb_Parque_originalMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: integer);
    procedure pb_Parque_originalMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: integer);
    procedure pb_Parque_simpleClick(Sender: TObject);
    procedure TabSheet3ContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure TabSheet4Show(Sender: TObject);

    procedure VelocidadesMT_To_PB(pb_Parque:TPaintBox);



  private
    { private declarations }
  public
    { public declarations }

   {$IFDEF pq_direct}
   dbpq: TDBPqCon;
  {$ELSE}
  dbpq: TDBrosxCon;
  {$ENDIF}

    //   ModeloParque: TModeloParqueEolico;
    CurvaAero: TCurvaAerogen;
    (*
    Afectacion: TAnemometro_MatR;
    TM: TMolino;
    MiP, MiV: NReal;
      *)
    nidCentral: integer;
    procedure CargarParametros_FormToParque;

  end;



var
  FormEstimadorGenERNC: TFormEstimadorGenERNC;
  i, total: integer;
  Calibrador: TCalibradorParque;
  Parque_MT: TParque_ModeloTeorico;
  Parque_ME: TParque_ModeloEmpirico;
  Parque_MC: TParque_ModeloCombinado;
  archiCalibrador, archiSeriesAProcesarMC: string;
  selMolino: TMolino;

implementation

{$R *.lfm}


{ TFormEstimadorGenERNC }


procedure fijarCalibrador(Calibrador: TCalibradorParque);
begin
  Parque_MT := Calibrador.Parque_MT;
  Parque_ME := Calibrador.parque_ME;
  parque_MT.SetPixFrame(0, 30, FormEstimadorGenERNC.pb_Parque_original.Width,
    FormEstimadorGenERNC.pb_Parque_original.Height);
  FormEstimadorGenERNC.Caption := 'Calibrador cargado, Parque: ' + Parque_MT.Nombre;
  FormEstimadorGenERNC.eGamma_Atmosfera.Text := FloatToStr(Parque_MT.gamma_atmosfera);
  FormEstimadorGenERNC.eAlfaTerreno.Text := FloatToStr(Parque_MT.alfa_terreno);
  FormEstimadorGenERNC.efpv3pe.Text := FloatToStr(Parque_MT.fpv3pe);
  FormEstimadorGenERNC.eFactorPerdidasParque.Text :=
    FloatToSTr(Parque_MT.Factor_Perdidas);
  FormEstimadorGenERNC.eLimiteDePotencia.Text :=
    FloatToStr(Parque_MT.Potencia_Autorizada_MW);
  FormEstimadorGenERNC.eEthaMeteo.Text := Parque_MT.Meteo_etha.serialize;


  FormEstimadorGenERNC.eGamma_Atmosfera1.Text := FloatToStr(Parque_MT.gamma_atmosfera);
  FormEstimadorGenERNC.eAlfaTerreno1.Text := FloatToStr(Parque_MT.alfa_terreno);
  FormEstimadorGenERNC.efpv3pe1.Text := FloatToStr(Parque_MT.fpv3pe);
  FormEstimadorGenERNC.eFactorPerdidasParque1.Text :=
    FloatToSTr(Parque_MT.Factor_Perdidas);
  FormEstimadorGenERNC.eLimiteDePotencia1.Text :=
    FloatToStr(Parque_MT.Potencia_Autorizada_MW);
  FormEstimadorGenERNC.eEthaMeteo2.Text := Parque_MT.Meteo_etha.serialize;


end;

procedure CargarParque(archi: string);
begin
  //  parque := upintado.Create_Pintado;
  Calibrador := TCalibradorParque.CreateLoadFromArchi(archi);
  fijarCalibrador(Calibrador);
  //Calibrador.WriteMamtrizComparativaCurvas('c:\basura\compartivacurvas.xlt');
end;


procedure CargarParque_MC(archi: string);
begin
  //  parque := upintado.Create_Pintado;
  Parque_MC := TParque_ModeloCombinado.CreateLoadFromArchi(archi);
  Calibrador := Parque_MC;
  fijarCalibrador(Parque_MC);
  Calibrador.WriteMamtrizComparativaCurvas('c:\basura\compartivacurvas.xlt');
end;

procedure TFormEstimadorGenERNC.btCalibrarParqueClick(Sender: TObject);
var
  f: textFile;
  err2: NReal;
  k: integer;

begin
  randseed := 31;

  (*
  if calibrador = nil then
   Calibrador:= TCalibradorParque.CreateLoadFromArchi( 'c:\basura\calibrador_Pintado.clp' );
    *)

  if parque_MT = nil then
    //   CargarParque( 'c:\basura\calibrador_Pintado.clp' );
    CargarParque('c:\basura\calibrador_MINAS I.clp');

  err2 := Calibrador.Calibrar(nil);
  eErr2Calibrar.Text := FloatToStr(err2);

  Calibrador.StoreInArchi('c:\basura\calibrador_' + parque_MT.Nombre + '_FIN_.clp');
end;

procedure TFormEstimadorGenERNC.btBajarParqueClick(Sender: TObject);
var
  r_central: TSQLQuery;
begin
  if parque_MT <> nil then
    parque_MT.Free;
  nidCentral := StrToInt(eNidCentral.Text); // 29 = MInas I
  writeln('... espere por favor ... conectando a la DB');
  r_central := dbpq.query('SELECT * FROM centrales WHERE nid = ' + IntToStr(nidCentral));
  parque_MT := TParque_ModeloTeorico.Create_LoadFromDB(dbpq, r_central);
  parque_MT.StoreInArchi(archi_parque_mt(nidCentral));
  writeln('... el Parque fue guardado en disco: ' + archi_parque_mt(nidCentral));
end;

procedure TFormEstimadorGenERNC.btCalcularMCClick(Sender: TObject);
var
  archiCalibrador_, archimc: string;
begin
  archiCalibrador_ := 'c:\basura\calibrador_tmp.txt';
  Calibrador.StoreInArchi(archiCalibrador_);
  parque_MC := TParque_ModeloCombinado.CreateLoadFromArchiCalibrador(archiCalibrador_);
  archimc := ChangeFileExt(archiCalibrador, '.pmc');
  parque_MC.StoreInArchi(archimc);
end;

procedure TFormEstimadorGenERNC.btCambiar_roClick(Sender: TObject);
var
  kMolino: integer;
  nuevoRo: NReal;

begin
  nuevoRo := StrToFloat(eEthaMolino.Text);
  if not cbCambiarTodosLosRo.Checked then
  begin
    if selMolino <> nil then
    begin
      selMolino.etha := nuevoRo;
    end;
  end
  else
  begin
    for kMolino := 0 to high(parque_MT.Molinos) do
      parque_MT.Molinos[kMolino].etha := NuevoRo;
  end;
end;



procedure TFormEstimadorGenERNC.btCargarCalibradorClick(Sender: TObject);
begin
  if odCalibrador.Execute then
  begin
    archiCalibrador := odCalibrador.FileName;
    CargarParque(archiCalibrador);
  end;
end;

procedure TFormEstimadorGenERNC.btCargarMCClick(Sender: TObject);
var
  archiMC: string;
begin
  if odCalibrador.Execute then
  begin
    archiMC := odCalibrador.FileName;
    CargarParque_MC(archiMC);

  end;
end;







procedure TFormEstimadorGenERNC.btGuardarCalibradorClick(Sender: TObject);
begin
  if (Calibrador <> nil) and sdCalibrador.Execute then
    Calibrador.StoreInArchi(sdCalibrador.FileName);
end;



procedure TFormEstimadorGenERNC.CargarParametros_FormToParque;
var
  vaux: TVectR;

begin

  Parque_MT.alfa_terreno := StrToFloat(eAlfaTerreno.Text);
  Parque_MT.gamma_atmosfera := StrToFloat(eGamma_Atmosfera.Text);

  Parque_MT.fpv3pe := StrToFloat(efpv3pe.Text);
  Parque_MT.Factor_Perdidas := StrToFloat(eFactorPerdidasParque.Text);
  Parque_MT.Potencia_Autorizada_MW := StrToFloat(eLimiteDePotencia.Text);

  vaux := TVectR.Create_unserialize(eEthaMeteo.Text);
  Parque_MT.Meteo_etha.Free;
  Parque_MT.Meteo_etha := vaux;

end;

procedure TFormEstimadorGenERNC.btCalcularClick(Sender: TObject);
var
  ang, pv: NReal;
  k, j: integer;
  kFil, jCol: integer;
  cl: TColor;
  rLibre: NReal;
  kMolino: integer;
  aMolino: TMolino;
  pvAtPix: NReal;
  xp, yp: integer;
  vAnemoEntrada: NReal;
  vAnemoResultante: NReal;
  PE_MW_MT, PE_MW_ME, peso_datos: NReal;

var
  //  bmp: TBitmap;
  vel: NReal;
  ColorVel: TEscalaColor;
  flg_Convergio: boolean;
  pv3_Anemo_s, pv3_Libre: NReal;

  aa: TTextStyle;
begin
  //  bmp := TBitmap.Create;
  //  barracolores_imglst.GetBitmap( 0, bmp);


  ColorVel := TEscalaColor.Create(4, 10);

  if parque_MT = nil then
    //   CargarParque( 'c:\basura\calibrador_Pintado.clp' );
    if odCalibrador.Execute then
      CargarParque(odCalibrador.FileName);


  Application.ProcessMessages;
  parque_MT.SetPixFrame(0, 30, pb_Parque_original.Width, pb_Parque_original.Height);

  pb_Parque_original.Canvas.Brush.Color := clWhite;
  pb_Parque_original.Canvas.Rectangle(0, 0, pb_Parque_original.Width, pb_Parque_original.Height);



  vAnemoEntrada := StrToFloat(eVAnemoEntrada.Text);
  ang := StrToFloat(eDir.Text);

  cargarParametros_FormToParque;

  pv := pv3Ofv(vAnemoEntrada, ro_BASE);
  parque_MT.Calc_PotMW_init_(ang);
  pe_MW_MT := parque_MT.Calc_PotMW_anemo(ro_Base, pv,
    Calibrador.Parque_MT.Potencia_Autorizada_MW, flg_Convergio, pv3_Anemo_s, pv3_Libre);
  PE_MW_ME := calibrador.Parque_ME.Calc_PE(ang, pv, ro_BASE, peso_datos);



  ePE_MW_ModeloTeorico.Text := FloatToStr(pe_MW_MT);

  pv := parque_MT.GridValAtZ(_0) * parque_MT.Meteo_etha_dir;

  vAnemoResultante := vOfpv3(pv, ro_Base);
  eVAnemoResultante.Text := FloatToStr(vAnemoResultante);

  ePE_MW_Representantes.Text := FloatToStr(PE_MW_ME);
  eME_Peso.Text := FloatToStr(peso_datos);

  VelocidadesMT_To_PB(pb_Parque_original);
  VelocidadesMT_To_PB(pb_Parque_simple);


end;


procedure TFormEstimadorGenERNC.btLevantarCurvaAeroADBClick(Sender: TObject);
var
  curvaAero: TCurvaAerogen;
begin
  (*
  curvaAero := TCurvaAerogen.CreateLoadFromArchi(
    'Vestas V112',
    'C:\simsee\SimSEE_src\trunk\ax\EstimadorGeneracionERNC\Curvas de potencia\Vestas_V112_ro1.txt');
  curvaAero := TCurvaAerogen.CreateLoadFromArchi(
    'Nordex N117',
    'C:\simsee\SimSEE_src\src\trunk\ax\EstimadorGeneracionERNC\Curvas de potencia\NordexN117_ro1.txt');

  curvaAero := TCurvaAerogen.CreateLoadFromArchi(
    'Bonus_150',
    'C:\simsee\SimSEE_src\src\trunk\ax\EstimadorGeneracionERNC\Curvas de potencia\Bonus150_ro1.txt');

  curvaAero := TCurvaAerogen.CreateLoadFromArchi(
    'Nordex N100/2.5',
    'C:\simsee\SimSEE_src\src\trunk\ax\EstimadorGeneracionERNC\Curvas de potencia\NordexN100_2500_ro1.txt');



    curvaAero := TCurvaAerogen.CreateLoadFromArchi(
        'Gamesa G90/2.0',
        'C:\simsee\SimSEE_src\src\trunk\ax\EstimadorGeneracionERNC\Curvas de potencia\Gamesa_G90_2000_ro1.txt');


  curvaAero := TCurvaAerogen.CreateLoadFromArchi(
      'ENERCON E92/2.35',
      'C:\simsee\SimSEE_src\src\trunk\ax\EstimadorGeneracionERNC\Curvas de potencia\ENERCON_E92_2350_ro1.txt');


  curvaAero := TCurvaAerogen.CreateLoadFromArchi(
      'Gamesa G97/2.0',
      'C:\simsee\SimSEE_src\src\trunk\ax\EstimadorGeneracionERNC\Curvas de potencia\Gamesa_G97_2000_ro1.txt');

  curvaAero := TCurvaAerogen.CreateLoadFromArchi(
      'Vestas V80/2.0',
      'C:\simsee\SimSEE_src\src\trunk\ax\EstimadorGeneracionERNC\Curvas de potencia\Vestas_V80_2000_ro1.txt');

  curvaAero := TCurvaAerogen.CreateLoadFromArchi(
      'Vestas V100/1.8',
      'C:\simsee\SimSEE_src\src\trunk\ax\EstimadorGeneracionERNC\Curvas de potencia\Vestas_V100_1800_ro1.txt');

  curvaAero := TCurvaAerogen.CreateLoadFromArchi(
      'Suzlon S95/2.1',
      'C:\simsee\SimSEE_src\src\trunk\ax\EstimadorGeneracionERNC\Curvas de potencia\Suzlon_S95_2100_ro1.txt');

  curvaAero := TCurvaAerogen.CreateLoadFromArchi(
      'Vestas V90/2.0',
      'C:\simsee\SimSEE_src\src\trunk\ax\EstimadorGeneracionERNC\Curvas de potencia\Vestas_V90_2000_ro1.txt');

  curvaAero := TCurvaAerogen.CreateLoadFromArchi(
      'Nordex N27/0.15',
      'C:\simsee\SimSEE_src\src\trunk\ax\EstimadorGeneracionERNC\Curvas de potencia\Nordex_N27_0150_ro1.txt');

  curvaAero := TCurvaAerogen.CreateLoadFromArchi(
      'NuevoManantial_500kW',
      'C:\simsee\SimSEE_src\src\trunk\ax\EstimadorGeneracionERNC\Curvas de potencia\NuevoManantial_500kW_bonus150_escalada.txt');

  curvaAero := TCurvaAerogen.CreateLoadFromArchi(
    'NuevoManantial_1000kW',
    'C:\simsee\SimSEE_src\src\trunk\ax\EstimadorGeneracionERNC\Curvas de potencia\NuevoManantial_1000kW_bonus150_escalada.txt');
        *)
  // curvaAero.CrearTablaDB( dbpq );

 // curvaAero.InsertIntoDB(dbpq);


(** Acomodo la potencia del Bonus 150
  CurvaAero:= TCurvaAerogen.CreateLoadFromDB_nid( dbpq, 3  );
  CurvaAero.curva_P.PorReal( 1000.0 );
  CurvaAero.UpdateDB( dbpq );
  *)

 // curvaAero.Free;
end;

procedure TFormEstimadorGenERNC.btLoadFromArchi_ModeloMTySeriesClick(Sender: TObject);
begin

  if parque_MT <> nil then
    parque_MT.Free;

  nidCentral := StrToInt(eNidCentral.Text); // 29 = MInas I

  parque_MT := TParque_ModeloTeorico.Create_LoadFromArchi(
    archi_parque_mt(nidCentral));

  parque_MT.SetPixFrame(0, 30, pb_Parque_original.Width, pb_Parque_original.Height);

  eAlfaTerreno.Text := FloatToStr(Parque_MT.alfa_terreno);
  eGamma_Atmosfera.Text := FloatToStr(Parque_MT.gamma_atmosfera);

  efpv3pe.Text := FloatToStr(Parque_MT.fpv3pe);
  eFactorPerdidasParque.Text := FloatToStr(Parque_MT.Factor_Perdidas);
  eLimiteDePotencia.Text := FloatToStr(Parque_MT.Potencia_Autorizada_MW);
  eEthaMeteo.Text := Parque_MT.Meteo_etha.Serialize;


  if Calibrador <> nil then
    Calibrador.Free;

  Calibrador := TCalibradorParque.Create(parque_MT, archi_series(nidCentral));
  Calibrador.StoreInArchi(archi_calibrador(nidCentral));
  fijarCalibrador(Calibrador);
end;

procedure TFormEstimadorGenERNC.btUpdateMTinDBClick(Sender: TObject);
begin
  Calibrador.parque_MT.Update(dbpq);
end;

procedure TFormEstimadorGenERNC.Button1Click(Sender: TObject);
var
  vAnemoEntrada, ang, pe_MW_MT, pe_MW_ME, pe_MW_MC_Sin_RO, pe_MW_MC_Con_Ro: NReal;
  pv: NReal;
  flg_Convergio: boolean;
  pv3_Anemo_s, peso_datos: NReal;

  s_vel: TVectR;
  s_PE_ME: TVectR;
  s_PE_MT: TVectR;
  s_PE_MC: TVectR;

  kVel: integer;

  sx, sy: TSerieGrafico;
  g: TGrafico;
  pv3_Libre: NReal;

begin
  s_vel := TVectR.Create_Init(Calibrador.parque_ME.Representantes_pv3_medio.n);
  s_PE_ME := TVectR.Create_Init(Calibrador.parque_ME.Representantes_pv3_medio.n);
  s_PE_MT := TVectR.Create_Init(Calibrador.parque_ME.Representantes_pv3_medio.n);
  s_PE_MC := TVectR.Create_Init(Calibrador.parque_ME.Representantes_pv3_medio.n);

  ang := StrToFloat(eDir.Text);


  cargarParametros_FormToParque;

  for kVel := 1 to s_vel.n do
  begin
    vAnemoEntrada := vOfpv3(Calibrador.parque_ME.Representantes_pv3_medio.e(kVel),
      ro_BASE);
    s_vel.pon_e(kVel, vAnemoEntrada);

    pv := pv3Ofv(vAnemoEntrada, ro_BASE);
    parque_MT.Calc_PotMW_init_(ang);
    pe_MW_MT := parque_MT.Calc_PotMW_anemo(ro_Base, pv,
      calibrador.parque_MT.Potencia_Autorizada_MW, flg_Convergio,
      pv3_Anemo_s, pv3_Libre);
    PE_MW_ME := calibrador.Parque_ME.Calc_PE(ang, pv, ro_BASE, peso_datos);
    parque_MC.Calc_PE_ConYSinRO(PE_MW_MC_Con_Ro, PE_MW_MC_Sin_RO,
      vAnemoEntrada, ang, ro_Base, 1000000);
    s_PE_ME.pon_e(kvel, Pe_MW_ME);
    s_PE_MT.Pon_e(kvel, PE_MW_MT);
    s_PE_MC.Pon_e(kvel, PE_MW_MC_Sin_Ro);

  end;



  // Grafico P_Vel (cluster )
  g := TGrafico.Create('PE_Cluster', TG_DispersionXY, 0);
  g.Titulo := 'Potencias ME y MT para el ángulo: ' +
    FloatToStrF(ang, fFFixed, 12, 1) + '°';
  g.eje_x.titulo := 'Velocidad de viento [m/s]';
  g.eje_y.titulo := 'Potencia eléctrica [MW]';

  // muestra
  sx := TSerieGrafico.Create('v', s_vel.toTDAOfNReal, nil, nil, '##.##', True);
  g.AddSerie(sx);

  sy := TSerieGrafico.Create('MW_ME', s_PE_ME.toTDAOfNReal, sx, g);
  sy.colorLinea := clGreen;
  sy.colorLineaMarcador := clGreen;
  sy.RadioMarcador := 2;
  sy.AnchoLineaMarcador := 1;
  g.AddSerie(sy);


  sy := TSerieGrafico.Create('MW_MT', s_PE_MT.toTDAOfNReal, sx, g);
  sy.colorLinea := clBlue;
  sy.colorLineaMarcador := clBlue;
  sy.RadioMarcador := 2;
  sy.AnchoLineaMarcador := 1;
  g.AddSerie(sy);

  sy := TSerieGrafico.Create('MW_MC', s_PE_MC.toTDAOfNReal, sx, g);
  sy.colorLinea := clNone;
  sy.colorLineaMarcador := clRed;
  sy.RadioMarcador := 2;
  sy.AnchoLineaMarcador := 1;
  g.AddSerie(sy);


  g.SaveJPG('c:\basura\curvas_MW_PE_MT_' + IntToStr(trunc(ang * 100)) +
    '.jpg', 2100, 1000);


  g.Draw(PaintBox1.Canvas, PaintBox1.Width, PaintBox1.Height);

  s_vel.Free;
  s_PE_ME.Free;
  s_PE_MT.Free;
  g.Free;
end;

procedure TFormEstimadorGenERNC.btProcesarSeriesConMCClick(Sender: TObject);
var
  factor_smec_scada:Nreal;
  ds:  TSQLQuery;
  sqlselect:string;
  recsEnergia10m:TDAofRecsEnergiaPorFecha;
begin

  odProcesarSeries.InitialDir :=
    CarpetaResultados_modelado_RO(Calibrador.parque_MT.nid_central);
  archiSeriesAProcesarMC := archi_series(Calibrador.parque_MT.nid_central);

  if odProcesarSeries.Execute then
    begin
    archiSeriesAProcesarMC := odProcesarSeries.FileName;

    sqlselect :='SELECT factor_smec_scada from centrales where nid='+IntToStr(Calibrador.parque_MT.nid_central);
    ds := dbpq.query(sqlselect);

    factor_smec_scada := ds.FieldByName('factor_smec_scada').AsFloat;
    parque_MC.Calcular_PE(archiSeriesAProcesarMC, FechaDesde.Date, FechaHasta.Date, FechaDesde.Date, FechaHasta.Date,factor_smec_scada,recsEnergia10m);
    end;



end;

procedure TFormEstimadorGenERNC.BorrarSupercentralClick(Sender: TObject);
var
nid_central_a_borrar, nid_modelo_a_borrar:integer;
dsModelo_a_borrar: TSQLQuery;
a_borrar:string;

begin
      nid_central_a_borrar := StrToInt(self.NIDsupercentralBorrar.Text);

      dsModelo_a_borrar := dbpq.query('SELECT * FROM modelo_teorico WHERE central = ' + IntToStr(
    nid_central_a_borrar ) + ' ORDER BY dt_creacion DESC LIMIT 1');

      if dsModelo_a_borrar.EOF then
        begin
         showmessage('La supercentral: ' + FloatToStr(nid_central_a_borrar) +' no existe');
         exit
        end

      else
      begin

      a_borrar:=  '¿Está seguro que desea borrar la supercentral: ' + FloatToStr(nid_central_a_borrar) +' ?';
      if messagedlg('ATENCIÓN!',a_borrar,mtConfirmation,[mbYes,mbNo],0)= mrYes then
      begin
      nid_modelo_a_borrar:= dsModelo_a_borrar.FieldByName('nid').AsInteger;

      dbpq.exec('DELETE FROM modelo_teorico WHERE central = ' + IntToStr(nid_central_a_borrar ));
      dbpq.exec('DELETE FROM modelo_teorico_etha_molinos WHERE nid_modelo = ' + IntToStr(nid_modelo_a_borrar ));

      showmessage('La supercentral ' + FloatToStr(nid_central_a_borrar) +' ha sido borrada');
      if parque_MT <> nil then
    parque_MT.Free;

      if calibrador <> nil then
    calibrador.Free;
      end
      else exit
      end;
end;

procedure TFormEstimadorGenERNC.CrearSupercentralClick(Sender: TObject);
var

  nid_centrales: TDAofNInt;
  nidC, nid_central_anemo:integer;


begin

  nid_centrales := StrToDAOfNInt(self.NIDcentralesAunir.Text, ';');
  nid_central_anemo := StrToInt(self.NIDcentralAnemo.Text);

  if parque_MT <> nil then
    parque_MT.Free;

  parque_MT := TParque_ModeloTeorico.CreateMultiParque_LoadFromDB(dbpq, nid_centrales,nid_central_anemo);
  nidC:=parque_MT.nid_central;
  parque_MT.StoreInArchi(archi_parque_mt(nidC));

  Calibrador:=TCalibradorParque.Create(parque_MT,archi_series(nidC));
  Calibrador.StoreInArchi(archi_calibrador(nidC));

   ///

  //nid := DB.nextval('curvas_aerogen');
  //| nid | activo | centralgeneradora | agentegenerador | estadoactual | departamento |
  //localidad | fechaentradaenservicio | tension_kv | potencia_autorizada_mw | latitud |
  //longitud | fabricante | modelo | potenciaaerogenerador_mw | cantidadaerogeneradores |
  //cota_asl | tipo | meteo_utm_zona | meteo_utm_huso | meteo_utm_xe | meteo_utm_yn | meteo_cota
  //| dt_ultimo_dump_scada | dt_primer_dump_scada | url_gmap | meteo_utm_zona2 |
  //meteo_utm_huso2 | meteo_utm_xe2 | meteo_utm_yn2 | meteo_cota2

  {sqlselect :=
    'SELECT  nid,centralgeneradora,agentegenerador,potencia_autorizada_mw, cantidadaerogeneradores, '
    + 'meteo_utm_zona,meteo_utm_huso,meteo_utm_xe,meteo_utm_yn,meteo_cota ' +
    'FROM centrales ' + 'WHERE nid = ' + IntToStr(nid_centrales[0]);

  for i := 1 to cant_centrales - 1 do
    sqlselect := sqlselect + ' or nid= ' + IntToStr(nid_centrales[i]);

  sqlselect := sqlselect + ' ORDER BY nid';

  ds := dbpq.query(sqlselect);}


end;

//function Inicializar_RecEnergiaHoraria (RecsRestricciones:TDAofRecsFechas):TDAofRecsEnergiaHoraria;
//var
//  res:TDAofRecsEnergiaHoraria;
//  cant_horas,k: integer;
//  FechaInicio,FechaFin:TDateTime;
//begin
//
//  if frac(RecsRestricciones[0].FechaDesde)=0 then
//    FechaInicio:=trunc(RecsRestricciones[0].FechaDesde)-1/24
//  else
//    FechaInicio:=trunc(RecsRestricciones[0].FechaDesde);//JFP aca esta mal, no hay que truncar asi
//
//  if frac(RecsRestricciones[high(RecsRestricciones)].FechaHasta)=0 then
//    FechaFin:=trunc(RecsRestricciones[high(RecsRestricciones)].FechaHasta)-1/24
//  else
//    FechaFin:=trunc(RecsRestricciones[high(RecsRestricciones)].FechaHasta);
//
//
//  cant_horas:=trunc((FechaFin-FechaInicio)*24+1);
//
//  setlength(res,cant_horas);
//
//  for k:=0 to cant_horas-1 do
//  begin
//    res[k].fecha:=FechaInicio+k/24;
//    res[k].energia:=0;
//  end;
//
//  Result:=res;
//end;

function GetRestricciones(archiSeries: string;
  PotenciaMaximaCentral: NReal): TDAofRecsFechas;
var
  series: TSeriesDeDatos;
  Res: TDAofRECSFechas;
  NDatos, k, j, kini, kfin: integer;
  sCGM: TVectR;
  termine: boolean;


  function buscoinicio(var k: integer): boolean;
  var
    buscando: boolean;
  begin
    buscando := True;
    while (k <= sCGM.n) and (buscando) do
      if ( sCGM.e(k) > -1) and( sCGM.e(k) < (PotenciaMaximaCentral - 0.5) ) then
        buscando := False
      else
        Inc(k);
    Result := not buscando;

  end;

  function buscofin(var k: integer): boolean;
  var
    buscando: boolean;
  begin
    buscando := True;
    while (k <= sCGM.n) and (buscando) do
      if ( sCGM.e(k) > -1) and (sCGM.e(k) > (PotenciaMaximaCentral - 0.5)) then
        buscando := False
      else
        Inc(k);
    Result := not buscando;

  end;

begin

  series := TSeriesDeDatos.CreateFromArchi(archiseries);

  NDatos := series.series[0].n;
  setlength(Res, NDatos);

  sCGM := series.series[6];
  k := 1;
  j := 0;
  termine:=false;

  while not termine do
  begin

    kini := k;
    if buscoinicio(kini) then
    begin
      kfin := kini + 1;
      buscofin(kfin);

      Res[j].FechaDesde := series.dtMuestra(kini);
      Res[j].FechaHasta := series.dtMuestra(kfin);
      k := kfin + 1;
      Inc(j);

      if kfin >= sCGM.n then

        termine := True;

    end
    else
      termine := True;


  end;

  setlength(Res, j);
  Result := Res;

end;

procedure TFormEstimadorGenERNC.btProcesarRestriccionesClick(Sender: TObject);
var
  RecFechas: TRecFechasRestriccion;
  Recs: TDAofRecsFechas;
  factor_smec_scada:NReal;
  ds: TSqlQuery;
  sqlselect,DIR:String;
  RecsEnergia10m,RecsEnergiaHoraria:TDAofRecsEnergiaPorFecha;
  f:TextFile;
  series :TSeriesDeDatos;
  archiSal_Ehoraria,archiSal_Ehoraria_DTE:String;
begin


  odProcesarSeries.InitialDir :=
    CarpetaResultados_modelado_RO(Calibrador.parque_MT.nid_central);
  archiSeriesAProcesarMC := archi_series(Calibrador.parque_MT.nid_central);

  if odProcesarSeries.Execute then
  begin
    archiSeriesAProcesarMC := odProcesarSeries.FileName;

    sqlselect :='SELECT factor_smec_scada from centrales where nid='+IntToStr(Calibrador.parque_MT.nid_central);
    ds := dbpq.query(sqlselect);

    factor_smec_scada := ds.FieldByName('factor_smec_scada').AsFloat;

    Recs := GetRestricciones(archiSeriesAProcesarMC,
      Calibrador.parque_MT.Potencia_Autorizada_MW);


    for i := 0 to high(Recs) do
    begin
      RecFechas := Recs[i];

      parque_MC.Calcular_PE(archiSeriesAProcesarMC,
        RecFechas.FechaDesde-4.0/24.0,
        RecFechas.FechaHasta+4.0/24.0,
        RecFechas.FechaDesde,
        RecFechas.FechaHasta,factor_smec_scada,RecsEnergia10m);

    end;

    archiSal_Ehoraria := CarpetaResultados_modelado_RO(parque_MT.nid_central) +
      '\c'+IntToStr(calibrador.parque_MT.nid_central) +'_Restricciones_horarias'+ '.xlt';

    archiSal_Ehoraria_DTE:= CarpetaResultados_modelado_RO(parque_MT.nid_central) +
      '\c'+IntToStr(calibrador.parque_MT.nid_central) +'_RO_DTE'+ '.xlt';

    RecsEnergiaHoraria:=Energia10mToEnergiaHoraria(RecsEnergia10m);

    //JFP:Escribe resumen de energia no sumistrada por hora.
    EnergiaPorFecha_To_XLT(archiSal_Ehoraria,RecsEnergiaHoraria,factor_smec_scada);

    //JFP:Escribe resumen de energia no sumistrada por hora y en formato DTE.
    {$IFNDEF VERSION_SIMPLE}
    EnergiaPorFecha_To_DTE(archiSal_Ehoraria_DTE,RecsEnergiaHoraria,factor_smec_scada,
     FechaDesde.Date,FechaHasta.Date);
    {$ENDIF}

  end;
end;

procedure TFormEstimadorGenERNC.CalcularReduccionClick(Sender: TObject);
var
  parque: TParque_ModeloTeorico;
  f, s: textFile;
  pv3_an, ro, cociente1, cociente2, diferencia1, diferencia2, sumnum,
  sumden, sumprom: NReal;
  NDatos, j, dia, buffer, k, i, x: integer; // largo de la series de datos
  series: TSeriesDeDatos; // las series históricas de datos
  sPot_MW, sDir_gr, sVel_mps, sTemp_grC, sPre_hPa, sHumRel_p100,
  sConsigna, sPot_MW_recortado, sPot_MW_modelo, sPot_MW_NoGenerada_nu1,
  sPot_MW_NoGenerada_nu2, nu1, nu2, num, den: TVectR;
  dir, vel_anemo, PE_Modelo, auxn, auxd, aux: NReal;
  sPot_MW_NoGenerada_nu_movil: TVectR;
  sPot_MW_NoGenerada_nu_inst: TVectR;

  convergio: boolean;
  pv3Anemo_s: NREal;

begin
  (***

  //Inicializa un parque con los parámetros de ajuste más recientes//
  //carga los datos climatológicos y de generacion del parque y calcula//                                             //
  //la relacion de potencia generada real y la del modelo, junto con la //
  //energía reducida//

  //cargo el modelo del parque//
    {//inicializo con parametros por defecto//
  parque := TParque_ModeloTeorico.Create_Init('Pintado', 30, 72,
  'Vestas V112',
  'C:\simsee\SimSEE_src\trunk\ax\EstimadorGeneracionERNC\Curvas de potencia\Vestas_V112_ro1.txt',
  0.005, // rugosidad???
  0.005, // gamma_atmosfera
  -3000, 3000, 1000, 3000, 12, 4, 9, 1, 1000);}

  //lo cargo con la ultima calibracion//
  assignfile(f,
    'C:\simsee\simsee_src\trunk\ax\EstimadorGeneracionERNC\mods_parques\calibrador_Pintado_FIN_.clp');
  reset(f);
  parque := TParque_ModeloTeorico.Create_LoadFromFile(f);
  closefile(f);

  //cargo los datos reales del parque//

  series := TSeriesDeDatos.CreateFromArchi(
    'C:\simsee\simsee_src\trunk\ax\EstimadorGeneracionERNC\mods_parques\DatosPintado2015_diezminutales_con_Consigna2.txt');
  NDatos := series.series[0].n;

  sPot_MW := series.series[0];
  sDir_gr := series.series[1];
  sVel_mps := series.series[3];

  sTemp_grC := series.series[4];
  sPre_hPa := series.series[5];
  sHumRel_p100 := series.series[6];
  sConsigna := series.series[8];

  //Creo una nueva serie de sPot_MW que respeta la consigna impuesta
  sPot_MW_recortado := TVectR.Create_Init(NDatos);
  sPot_MW_modelo := TVectR.Create_Init(NDatos);

  sPot_MW_NoGenerada_nu_movil := TVectR.Create_Init(NDatos);
  sPot_MW_NoGenerada_nu_inst := TVectR.Create_Init(NDatos);

  for j := 1 to NDatos do
  begin
    if (sConsigna.e(j) <> -1) then
      if (sPot_MW.e(j) <= sConsigna.e(j)) then
        sPot_MW_recortado.pon_e(j, sPot_MW.e(j))
      else
        sPot_MW_recortado.pon_e(j, sConsigna.e(j))
    else
      sPot_MW_recortado.pon_e(j, sPot_MW.e(j));
  end;

  // Calculo una serie "sPot_MW_modelo" que representa la potencia generada por el modelo del parque//

  for j := 1 to NDatos do
  begin
    dir := sDir_gr.e(j);
    parque.Calc_PotMW_init_(dir);
    ro := ro_aire(sTemp_grC.e(j), sPre_hPa.e(j), sHumRel_p100.e(j));
    vel_anemo := sVel_mps.e(j);
    pv3_an := pv3Ofv(vel_anemo, ro);
    PE_Modelo := parque.Calc_PotMW_anemo(ro, pv3_an, convergio, pv3Anemo_s);
    sPot_MW_modelo.pon_e(j, PE_Modelo);
    // writeln( 'dir: ', dir: 6:1, ', vAnemo: ', vel_anemo: 12:2, ', PParque: ',  PE_Modelo: 12:2);
  end;

  //Calculo el rendimiento "nu" de mi estimacion como el cociente entre la potencia generada
  //por el modelo con respecto a la realmente generada por el parque antes de que
  //comience la reducción. Este parámetro lo voy llevando con una ventana
  //móvil de 24 hrs (6 muestras/hrs*24hrs) hasta el comienzo de una restricción,y luego
  //pasa a valer -1 como etiqueta durante la reducción//

  buffer := 6 * 24;
  num := TVectR.Create_Init(buffer);
  den := TVectR.Create_Init(buffer);

  nu1 := TVectR.Create_Init(NDatos);
  nu2 := TVectR.Create_Init(NDatos);
  num.Ceros;
  den.Ceros;
  nu1.Ceros;
  nu2.Ceros;
  i := 1;

  // Inicialización del estimador de relación ModeloCP/ModeloLP
  for j := 1 to NDatos do
  begin
    if (sConsigna.e(j) = -1) then
    begin

      if i > buffer then
      begin
        for  x := 1 to buffer - 1 do
        begin
          num.pon_e(x, num.e(x + 1));
          den.pon_e(x, den.e(x + 1));

        end;
        i := buffer;
      end;

      num.pon_e(i, sPot_MW_recortado.e(j));
      den.pon_e(i, sPot_MW_modelo.e(j));
      sumnum := 0;
      sumden := 0;
      sumprom := 0;
      for  x := 1 to i do
      begin
        sumnum := sumnum + num.e(x);
        sumden := sumden + den.e(x);
        auxd := den.e(x);
        auxn := num.e(x);
        if auxd < 0.01 then
          aux := 0
        else
          aux := auxn / auxd;
        sumprom := sumprom + aux;
      end;
      cociente2 := sumprom / i;
      if sumden < 0.01 then
        cociente1 := 0
      else
        cociente1 := sumnum / sumden;

      nu1.pon_e(j, cociente1);
      nu2.pon_e(j, cociente2);

      Inc(i);
    end

    else
    begin
      nu1.pon_e(j, nu1.e(j - 1));
      nu2.pon_e(j, nu2.e(j - 1));
    end;

  end;

  //Calculo de la potencia que se redujo
  for j := 1 to NDatos do
  begin
    if (sConsigna.e(j) <> -1) then
    begin
      diferencia1 := sPot_MW_modelo.e(j) * nu1.e(j) - sPot_MW_recortado.e(j);
      sPot_MW_NoGenerada_nu1.pon_e(j, diferencia1);
      diferencia2 := sPot_MW_modelo.e(j) * nu2.e(j) - sPot_MW_recortado.e(j);
      sPot_MW_NoGenerada_nu2.pon_e(j, diferencia2);
    end;
  end;

  //Salvo las series a un archivo
  assignfile(s, 'C:\simsee\simsee_src\trunk\ax\EstimadorGeneracionERNC\mods_parques\salida.txt'
    );
  rewrite(s);

  writeln(s, 'NDatos', #9, NDatos);
  writeln(s, 'Dir', #9, 'Vel', #9, 'Potencia real', #9, 'Consigna', #9,
    'Potencia con consigna', #9, 'Potencia modelo', #9, 'nu 1', #9, 'nu 2',
    #9, 'Potencia no generada con nu móvil', #9, 'Potencia no generada con nu inst.');

  for k := 1 to NDatos do

    writeln(s, sDir_gr.e(k), #9, sVel_mps.e(k), #9, sPot_MW.e(k), #9,
      sConsigna.e(k), #9, sPot_MW_recortado.e(k), #9, sPot_MW_modelo.e(k), #9,
      nu1.e(k), #9, nu2.e(k), #9, sPot_MW_NoGenerada_nu1.e(k), #9,
      sPot_MW_NoGenerada_nu2.e(k));

  closefile(s);
  *)
end;

procedure TFormEstimadorGenERNC.eDir1Change(Sender: TObject);
begin
  eDir.Text := eDir1.Text;
end;

procedure TFormEstimadorGenERNC.eDirChange(Sender: TObject);
begin
  eDir1.Text := eDir.Text;
end;

procedure TFormEstimadorGenERNC.eVAnemoEntrada1Change(Sender: TObject);
begin
  eVAnemoEntrada.Text:=eVAnemoEntrada1.Text;
end;

procedure TFormEstimadorGenERNC.eVAnemoEntradaChange(Sender: TObject);
begin
  eVAnemoEntrada1.Text:=eVAnemoEntrada.Text;
end;

procedure TFormEstimadorGenERNC.eAlfaTerreno1Change(Sender: TObject);
begin
  eAlfaTerreno.Text:=eAlfaTerreno1.Text;
end;

procedure TFormEstimadorGenERNC.eAlfaTerrenoChange(Sender: TObject);
begin
  eAlfaTerreno1.Text:=eAlfaTerreno.Text;
end;

procedure TFormEstimadorGenERNC.eGamma_Atmosfera1Change(Sender: TObject);
begin
  eGamma_Atmosfera.Text:=eGamma_Atmosfera1.Text;
end;

procedure TFormEstimadorGenERNC.eGamma_AtmosferaChange(Sender: TObject);
begin
  eGamma_Atmosfera1.Text:=eGamma_Atmosfera.Text;
end;

procedure TFormEstimadorGenERNC.efpv3pe1Change(Sender: TObject);
begin
  efpv3pe.Text:=efpv3pe1.Text;
end;

procedure TFormEstimadorGenERNC.efpv3peChange(Sender: TObject);
begin
  efpv3pe1.Text:=efpv3pe.Text;
end;

procedure TFormEstimadorGenERNC.eFactorPerdidasParque1Change(Sender: TObject);
begin
  eFactorPerdidasParque.Text:=eFactorPerdidasParque1.Text;
end;

procedure TFormEstimadorGenERNC.eFactorPerdidasParqueChange(Sender: TObject);
begin
  eFactorPerdidasParque1.Text:=eFactorPerdidasParque.Text;
end;

procedure TFormEstimadorGenERNC.eLimiteDePotencia1Change(Sender: TObject);
begin
  eLimiteDePotencia.Text:=eLimiteDePotencia1.Text;
end;

procedure TFormEstimadorGenERNC.eLimiteDePotenciaChange(Sender: TObject);
begin
  eLimiteDePotencia1.Text:=eLimiteDePotencia.Text;
end;

procedure TFormEstimadorGenERNC.eEthaMeteo2Change(Sender: TObject);
begin
  eEthaMeteo.Text:=eEthaMeteo2.Text;
end;

procedure TFormEstimadorGenERNC.eEthaMeteoChange(Sender: TObject);
begin
  eEthaMeteo2.Text:=eEthaMeteo.Text;
end;

procedure TFormEstimadorGenERNC.eME_PesoChange(Sender: TObject);
begin
  eME_Peso1.Text:=eME_Peso.Text;
end;

procedure TFormEstimadorGenERNC.ePE_MW_ModeloTeoricoChange(Sender: TObject);
begin
  ePE_MW_ModeloTeorico1.Text:=ePE_MW_ModeloTeorico.text;
end;

procedure TFormEstimadorGenERNC.ePE_MW_RepresentantesChange(Sender: TObject);
begin
  ePE_MW_Representantes1.Text:=ePE_MW_Representantes.Text;
end;

procedure TFormEstimadorGenERNC.eVAnemoResultanteChange(Sender: TObject);
begin
  eVAnemoResultante1.Text:=eVAnemoResultante.Text;
end;

procedure TFormEstimadorGenERNC.FechaDesde1Change(Sender: TObject);
begin
  FechaDesde.Date:=FechaDesde1.Date;
end;

procedure TFormEstimadorGenERNC.FechaHasta1Change(Sender: TObject);
begin
  FechaHasta.Date:=FechaHasta1.Date;
end;


procedure TFormEstimadorGenERNC.eEthaMeteo1Change(Sender: TObject);
begin
  eEthaMeteo.Text := eEthaMeteo1.Text;
end;

procedure TFormEstimadorGenERNC.FormClose(Sender: TObject;
  var CloseAction: TCloseAction);
begin

  if parque_MT <> nil then
    parque_MT.Free;

  if parque_MC <> nil then
    parque_MC.Free;

  if dbpq <> nil then
    dbpq.Free;
end;


procedure TFormEstimadorGenERNC.FormCreate(Sender: TObject);
begin
  {$IFDEF MODELO_PARQUE}
  ModeloParque := nil;
  {$ENDIF}
  Calibrador := nil;
  Parque_MT := nil;
  Parque_MC := nil;
  {$IFDEF pq_direct}
  dbpq := TDBPQCon.Create('condb_rbtdata.dat');
  {$ELSE}
  dbpq:= TDBrosxCon.Create('', 'pronos.adme.com.uy', 80, '/scripts/rosx.php');
  {$ENDIF}
   eVAnemoEntrada.Text := FloatToStr(9.9);
  eGamma_Atmosfera.Text := FloatToStr(0.4);
  eAlfaTerreno.Text := FloatToStr(0.5);


  {$IFDEF VERSION_SIMPLE}
  TabSheet1.TabVisible:=false;
  TabSheet2.TabVisible:=false;
  TabSheet3.TabVisible:=false;
  TabSheet4.TabVisible:=false;
  {$ENDIF}

end;

procedure TFormEstimadorGenERNC.GroupBox2Click(Sender: TObject);
begin

end;

procedure TFormEstimadorGenERNC.Label7Click(Sender: TObject);
begin

end;

procedure TFormEstimadorGenERNC.NIDcentralAnemoChange(Sender: TObject);
begin

end;

procedure TFormEstimadorGenERNC.NIDcentralesAunirChange(Sender: TObject);
begin

end;




procedure TFormEstimadorGenERNC.pb_Parque_originalMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: integer);
var
  xp1, yp1, xp2, yp2: integer;
  z1, z2: Complex;
var
  pb_EstelaMolino: TBitmap; // para copiar temporalmente la pantallita.

begin
  if Parque_MT = nil then
    exit;

  SelMolino := Parque_MT.MolinoAt_xpyp(x, y);
  if selMolino <> nil then
  begin
    eEthaMolino.Text := FloatToStr(selMolino.etha);
    z1 := selMolino.posicion.z_base + cinit(-selMolino.curva.Diametro,
      6 * selMolino.curva.Diametro);
    z2 := selMolino.posicion.z_base + cinit(15 * selMolino.curva.Diametro,
      -6 * selMolino.curva.Diametro);

    parque_MT.ZToPix(xp1, yp1, z1);
    parque_MT.ZToPix(xp2, yp2, z2);

    pb_EstelaMolino := TBitmap.Create;

    pb_EstelaMolino.Width := xp2 - xp1 + 1;
    pb_EstelaMolino.Height := yp2 - yp1 + 1;

    pb_EstelaMolino.Canvas.CopyRect(
      Rect(0, 0, pb_EstelaMolino.Width, pb_EstelaMolino.Height), pb_Parque_original.Canvas,
      Rect(xp1, yp1, xp2, yp2));
    Clipboard.Assign(pb_EstelaMolino);

    pb_EstelaMolino.Free;

  end;

end;

procedure TFormEstimadorGenERNC.pb_Parque_originalMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: integer);
var
  z: Complex;

  Molino: TMolino;
begin
  if Parque_MT = nil then
    exit;

  Parque_MT.PixToZ(z, x, y);
  eCoordenadasXY.Text := 'x: ' + FloatToStr(z.re) + ', y: ' + FloatToStr(z.im);

  Molino := Parque_MT.MolinoAt_xpyp(x, y);
  if Molino <> nil then
  begin
    eMolino.Text := 'v: ' + FloatToStrF(vOfpv3(Molino.pv_prom, ro_Base),
      ffFixed, 6, 1) + ', P:' + FloatToStrF(Molino.PE_MW, ffFixed, 6, 1);
  end;

end;

procedure TFormEstimadorGenERNC.pb_Parque_simpleClick(Sender: TObject);
begin

end;

procedure TFormEstimadorGenERNC.TabSheet3ContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
begin

end;


procedure TFormEstimadorGenERNC.TabSheet4Show(Sender: TObject);
begin
  eEthaMeteo1.Text := eEthaMeteo.Text;
end;


procedure TFormEstimadorGenERNC.VelocidadesMT_To_PB(pb_Parque: TPaintBox);

var
k, j: integer;
cl: TColor;
pvAtPix: NReal;
xp, yp: integer;



var
//  bmp: TBitmap;
vel: NReal;
ColorVel: TEscalaColor;
flg_Convergio: boolean;
pv3_Anemo_s, pv3_Libre: NReal;

aa: TTextStyle;
begin
//  bmp := TBitmap.Create;
//  barracolores_imglst.GetBitmap( 0, bmp);


ColorVel := TEscalaColor.Create(4, 10);

if parque_MT = nil then
  //   CargarParque( 'c:\basura\calibrador_Pintado.clp' );
  if odCalibrador.Execute then
    CargarParque(odCalibrador.FileName);


Application.ProcessMessages;
parque_MT.SetPixFrame(0, 30, pb_Parque.Width, pb_Parque.Height);

pb_Parque.Canvas.Brush.Color := clWhite;
pb_Parque.Canvas.Rectangle(0, 0, pb_Parque.Width, pb_Parque.Height);




for k := 0 to pb_Parque.Width - 1 do
begin
  vel := 6 * k / pb_Parque.Width + 4;
  cl := ColorVel.Color(vel);
  for j := 0 to 29 do
    pb_Parque.Canvas.Pixels[k, j] := cl;

end;



for k := 1 to 5 do
begin
  cl := clBlack;
  for j := 0 to 29 do
    pb_Parque.Canvas.Pixels[trunc(k*pb_Parque.Width/6), j] := cl;
  pb_Parque.Canvas.TextOut(trunc(k*pb_Parque.Width/6)+2, 0, FloatToStr(Roundto(6 * k*pb_Parque.Width/6 / pb_Parque.Width + 4,-1)));
end;


pb_Parque.Canvas.TextOut(0, 0, '4');
pb_Parque.Canvas.TextOut(0, 15, 'Vel (m/s)');
pb_Parque.Canvas.TextOut(pb_Parque.Width - 13, 0, '10');


for k := 0 to pb_Parque.Width - 1 do
  for j := 30 to pb_Parque.Height - 1 do
  begin
    pvAtPix := parque_MT.GridValAtPix(k, j);
    vel := vOfpv3(pvAtPix, ro_base);
    if vel > 0 then
    begin
      cl := ColorVel.Color(vel);
      (*
      rLibre := (1-min( max( vOfpv3( pvAtPix, ro_base )-4.0, 0 )/6.0, 1.0))*632;
      cl:= bmp.Canvas.Pixels[15, trunc( rlibre )];
      *)
      pb_Parque.Canvas.Pixels[k, j] := cl;

    end;
  end;


(*
for kMolino:= 0 to high( Parque.Molinos ) do
begin
  aMolino:= parque.molinos[kMolino];
  Parque.zToPix( xp, yp, aMolino.posicion.z_base );
  pb_Parque.Canvas.TextOut( xp, yp, 'W:'+IntToStr( kMolino+1 )+',P:'+ FloatToStrF( aMolino.PE_MW, ffFixed, 12, 2  )
    +'('+FloatToStrF( aMolino.posicion.z_base.re, ffFixed, 12, 2  )+':'+FloatToStrF( aMolino.posicion.z_base.im, ffFixed, 12, 2  )+')' );
end;
 *)

Parque_MT.zToPix(xp, yp, _0);
pb_Parque.Canvas.TextOut(xp, yp, '(A)');

//  bmp.Free;


end;


end.
