unit uiterador_laplaciano_nulo;

{$mode delphi}

    interface


uses
  Classes, SysUtils,xmatdefs, matreal;


procedure Barrido_ImponerBorde(var MatrizFactor: TMatR;
     MatrizBorde: TMatR);

function Barrido_PromediarCasilleros(var MatrizFactor: TMatR;
     MatrizBorde: TMatR): NReal;

procedure Rellenar_matriz (var Matriz_c,Matriz_b:TMatR;var epsilon:NReal; var cnt_iter:integer );


implementation


procedure Barrido_ImponerBorde(var MatrizFactor: TMatR;
  MatrizBorde: TMatR);
var
  Nfilas, Ncolumnas: integer;
  fila, col: integer;

begin
  Nfilas := MatrizFactor.nf;
  Ncolumnas := MatrizFactor.nc;

  for fila := 1 to Nfilas do
    for col := 1 to Ncolumnas do
    begin
      if MatrizBorde.e(fila, col) > 0 then
        MatrizFactor.pon_e(fila, col, MatrizBorde.e(fila, col));
    end;


end;

    function Barrido_PromediarCasilleros(var MatrizFactor: TMatR;
  MatrizBorde: TMatR): NReal;
var

  m, n: integer;
  k, j: integer;
  mx, my: TMatR;


begin

  m := MatrizFactor.nf;
  n := MatrizFactor.nc;

  mx:= TMatR.Create_Clone(MatrizFactor);
  my := MatrizFactor;

  begin
  for k := 1 to m do
    for j := 1 to n do
    begin
    if MatrizBorde.e( k, j ) <= 0 then
    if n>1 then
      begin
        if ( k> 1) and (j> 1) and (k< m) and (j<n) then
        begin
           my.pon_e( k, j ,
             ( mx.e( k, j-1 ) + mx.e( k, j+1 ) + mx.e(k-1, j )+ mx.e(k+1,j) )/ 4 )
        end
        else
        if k = 1 then
        begin
          if j = 1 then
            my.pon_e( k, j ,
              ( mx.e( k, j ) + mx.e( k, j+1 ) + mx.e( m, j )+ mx.e(k+1,j) )/ 4 )
          else if j = n then
            my.pon_e( k, j ,
              ( mx.e( k, j-1 ) + mx.e( k, j ) + mx.e( m, j )+ mx.e(k+1,j) )/ 4 );
        end
        else // k = m
        begin
          if j = 1 then
            my.pon_e( k, j ,
            ( mx.e( k, j ) + mx.e( k, j+1 ) + mx.e(k-1, j )+ mx.e( 1,j) )/ 4 )
          else if j = n then
            my.pon_e( k, j ,
            ( mx.e( k, j-1 ) + mx.e( k, j ) + mx.e(k-1, j )+ mx.e( 1,j) )/ 4 )
        end;
     end
     else
     begin
       if k = 1 then
           my.pon_e( k, j ,
             ( mx.e(k+1 , j ) + mx.e( m, j ) )/ 2 )
       else if  k = m then
          my.pon_e( k, j ,
             ( mx.e(k-1 , j ) + mx.e( 1, j ) )/ 2 )
       else
          my.pon_e( k, j ,
             ( mx.e(k-1 , j ) + mx.e( k+1, j ) )/ 2 )
     end;

    end;

  mx.PorReal(-1);
  mx.Suma( mx, my );

  Result := abs( mx.MaxVal );

  mx.Free;


end;
end;


procedure Rellenar_matriz (var Matriz_c,Matriz_b:TMatR;var epsilon:NReal; var cnt_iter:integer );

   var Max_cnt_iter:integer;
  begin

   Max_cnt_iter := 10000;
   cnt_iter := 0;
   Barrido_ImponerBorde(Matriz_c, Matriz_b);

   repeat
      epsilon :=  Barrido_PromediarCasilleros(Matriz_c, Matriz_b);
      writeln( 'cnt_iter: ', cnt_iter, ', epsilon: ', epsilon );
      cnt_iter := cnt_iter + 1;
    until ((cnt_iter > Max_cnt_iter) or (epsilon < 1e-4));

  end;


end.

