unit uLectorInfoSCADA;


interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, xmatdefs, matreal, uauxiliares, strutils, uregistros;

type

  { TForm1 }

  TForm1 = class(TForm)
    btAbrirArchivo: TButton;
    eArchi: TLabeledEdit;
    OpenDialog1: TOpenDialog;
    procedure btAbrirArchivoClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }


var
  ActorActual, SerieActual: string;
  aTramo: TTramosAsincronosLst;
  aActorData: TColeccionDeRegistros;
  aRegSincro: TRegistroSampleoUniforme;
  dts10min: TDateTime;


procedure CierroActor;
begin
  aActorData.WriteToArchi('c:\basura\'+ActorActual+'.xlt' );
  aActorData.Free;
  aActorData:= nil;
end;

procedure CierroSerie;
begin
  if aTramo.Count > 0 then
  begin
    aTramo.Unificar;
    aRegSincro:= TRegistroSampleoAsincrono( aTramo.items[0] ).Resampling( dts10min );
    aActorData.add( aRegSincro );
  end;
  aTramo.Free;
  aTramo:= niL;
end;

procedure AbroActor( idActor: string );
begin
  aActorData:= TColeccionDeRegistros.Create;
  ActorActual:= idActor;
end;

procedure AbroSerie( idActor, idSerie: string );
begin
   aTramo:= TTramosAsincronosLst.Create( idActor, idSerie );
   SerieActual:= idSerie;
end;

procedure ProcesarArchivo( archi: string );
var
  idActor: string;
  idSerie: string;
  s: string;
  i: integer;
begin

writeln( 'Procesando: ', archi );

  s:= archi;
  i:= pos( '.', s);
  idActor:= copy( s, 1, i-1 );
  delete( s, 1, i+4 );
  i:= pos( '.', s);
  idSerie:= copy( s, 1, i-1 );

  if aTramo = nil then
    abroSerie( idActor, idSerie );
  if aActorData = nil then
    abroActor( idActor );

  if idActor = ActorActual then
  begin
    if idSerie <> SerieActual then
    begin
      CierroSerie;
      abroSerie( idActor, idSerie );
    end;
  end
  else
  begin
    CierroSerie;
    CierroActor;
    AbroActor( idActor );
    AbroSerie( idActor, idSerie );
  end;
  aTramo.AddFromArchi(archi)
end;



procedure TForm1.btAbrirArchivoClick(Sender: TObject);
begin
dts10min:= 1.0/24.0/6.0;

aTramo:= nil;
aActorData:= nil;

ProcesarArchivo('EFLOR1.000 CONSIGNA P.AV.2015.01.txt');
ProcesarArchivo('EFLOR1.000 CONSIGNA P.AV.2015.02.txt');
ProcesarArchivo('EFLOR1.000 CONSIGNA P.AV.2015.03.txt');
ProcesarArchivo('EFLOR1.000 CONSIGNA P.AV.2015.04.txt');
ProcesarArchivo('EFLOR1.000 CONSIGNA P.AV.2015.05.txt');
ProcesarArchivo('EFLOR1.000 CONSIGNA P.AV.2015.06.txt');
ProcesarArchivo('EFLOR1.000 CONSIGNA P.AV.2015.07.txt');
ProcesarArchivo('EFLOR1.000 CONSIGNA P.AV.2015.08.txt');
 ProcesarArchivo('EFLOR1.000 CONSIGNA P.AV.2015.09.txt');
 ProcesarArchivo('EFLOR1.000 CONSIGNA P.AV.2015.10.txt');
 ProcesarArchivo('EFLOR1.000 DIR VIENTO 85M 1.AV.2015.01.txt');
 ProcesarArchivo('EFLOR1.000 DIR VIENTO 85M 1.AV.2015.02.txt');
 ProcesarArchivo('EFLOR1.000 DIR VIENTO 85M 1.AV.2015.03.txt');
 ProcesarArchivo('EFLOR1.000 DIR VIENTO 85M 1.AV.2015.04.txt');
 ProcesarArchivo('EFLOR1.000 DIR VIENTO 85M 1.AV.2015.05.txt');
 ProcesarArchivo('EFLOR1.000 DIR VIENTO 85M 1.AV.2015.06.txt');
 ProcesarArchivo('EFLOR1.000 DIR VIENTO 85M 1.AV.2015.07.txt');
 ProcesarArchivo('EFLOR1.000 DIR VIENTO 85M 1.AV.2015.08.txt');
 ProcesarArchivo('EFLOR1.000 DIR VIENTO 85M 1.AV.2015.09.txt');
 ProcesarArchivo('EFLOR1.000 DIR VIENTO 85M 1.AV.2015.10.txt');
 ProcesarArchivo('EFLOR1.000 DIR VIENTO 85M 2.AV.2015.01.txt');
 ProcesarArchivo('EFLOR1.000 DIR VIENTO 85M 2.AV.2015.02.txt');
 ProcesarArchivo('EFLOR1.000 DIR VIENTO 85M 2.AV.2015.03.txt');
 ProcesarArchivo('EFLOR1.000 DIR VIENTO 85M 2.AV.2015.04.txt');
 ProcesarArchivo('EFLOR1.000 DIR VIENTO 85M 2.AV.2015.05.txt');
 ProcesarArchivo('EFLOR1.000 DIR VIENTO 85M 2.AV.2015.06.txt');
 ProcesarArchivo('EFLOR1.000 DIR VIENTO 85M 2.AV.2015.07.txt');
 ProcesarArchivo('EFLOR1.000 DIR VIENTO 85M 2.AV.2015.08.txt');
 ProcesarArchivo('EFLOR1.000 DIR VIENTO 85M 2.AV.2015.09.txt');
 ProcesarArchivo('EFLOR1.000 DIR VIENTO 85M 2.AV.2015.10.txt');
 ProcesarArchivo('EFLOR1.000 HUMEDAD.AV.2015.01.txt');
 ProcesarArchivo('EFLOR1.000 HUMEDAD.AV.2015.02.txt');
 ProcesarArchivo('EFLOR1.000 HUMEDAD.AV.2015.03.txt');
 ProcesarArchivo('EFLOR1.000 HUMEDAD.AV.2015.04.txt');
 ProcesarArchivo('EFLOR1.000 HUMEDAD.AV.2015.05.txt');
 ProcesarArchivo('EFLOR1.000 HUMEDAD.AV.2015.06.txt');
 ProcesarArchivo('EFLOR1.000 HUMEDAD.AV.2015.07.txt');
 ProcesarArchivo('EFLOR1.000 HUMEDAD.AV.2015.08.txt');
 ProcesarArchivo('EFLOR1.000 HUMEDAD.AV.2015.09.txt');
 ProcesarArchivo('EFLOR1.000 HUMEDAD.AV.2015.10.txt');
 ProcesarArchivo('EFLOR1.000 PRESION.AV.2015.01.txt');
 ProcesarArchivo('EFLOR1.000 PRESION.AV.2015.02.txt');
ProcesarArchivo('EFLOR1.000 PRESION.AV.2015.03.txt');
ProcesarArchivo('EFLOR1.000 PRESION.AV.2015.04.txt');
 ProcesarArchivo('EFLOR1.000 PRESION.AV.2015.05.txt');
 ProcesarArchivo('EFLOR1.000 PRESION.AV.2015.06.txt');
 ProcesarArchivo('EFLOR1.000 PRESION.AV.2015.07.txt');
ProcesarArchivo('EFLOR1.000 PRESION.AV.2015.08.txt');
ProcesarArchivo('EFLOR1.000 PRESION.AV.2015.09.txt');
ProcesarArchivo('EFLOR1.000 PRESION.AV.2015.10.txt');
 ProcesarArchivo('EFLOR1.000 TEMPERATURA 86M.AV.2015.01.txt');
ProcesarArchivo('EFLOR1.000 TEMPERATURA 86M.AV.2015.02.txt');
 ProcesarArchivo('EFLOR1.000 TEMPERATURA 86M.AV.2015.03.txt');
 ProcesarArchivo('EFLOR1.000 TEMPERATURA 86M.AV.2015.04.txt');
ProcesarArchivo('EFLOR1.000 TEMPERATURA 86M.AV.2015.05.txt');
 ProcesarArchivo('EFLOR1.000 TEMPERATURA 86M.AV.2015.06.txt');
 ProcesarArchivo('EFLOR1.000 TEMPERATURA 86M.AV.2015.07.txt');
 ProcesarArchivo('EFLOR1.000 TEMPERATURA 86M.AV.2015.08.txt');
 ProcesarArchivo('EFLOR1.000 TEMPERATURA 86M.AV.2015.09.txt');
 ProcesarArchivo('EFLOR1.000 TEMPERATURA 86M.AV.2015.10.txt');
 ProcesarArchivo('EFLOR1.000 VEL VIENTO 32 5M.AV.2015.01.txt');
 ProcesarArchivo('EFLOR1.000 VEL VIENTO 32 5M.AV.2015.02.txt');
 ProcesarArchivo('EFLOR1.000 VEL VIENTO 32 5M.AV.2015.03.txt');
ProcesarArchivo('EFLOR1.000 VEL VIENTO 32 5M.AV.2015.04.txt');
ProcesarArchivo('EFLOR1.000 VEL VIENTO 32 5M.AV.2015.05.txt');
 ProcesarArchivo('EFLOR1.000 VEL VIENTO 32 5M.AV.2015.06.txt');
 ProcesarArchivo('EFLOR1.000 VEL VIENTO 32 5M.AV.2015.07.txt');
ProcesarArchivo('EFLOR1.000 VEL VIENTO 32 5M.AV.2015.08.txt');
 ProcesarArchivo('EFLOR1.000 VEL VIENTO 32 5M.AV.2015.09.txt');
ProcesarArchivo('EFLOR1.000 VEL VIENTO 32 5M.AV.2015.10.txt');
ProcesarArchivo('EFLOR1.000 VEL VIENTO 89M.AV.2015.01.txt');
 ProcesarArchivo('EFLOR1.000 VEL VIENTO 89M.AV.2015.02.txt');
 ProcesarArchivo('EFLOR1.000 VEL VIENTO 89M.AV.2015.03.txt');
 ProcesarArchivo('EFLOR1.000 VEL VIENTO 89M.AV.2015.04.txt');
 ProcesarArchivo('EFLOR1.000 VEL VIENTO 89M.AV.2015.05.txt');
 ProcesarArchivo('EFLOR1.000 VEL VIENTO 89M.AV.2015.06.txt');
 ProcesarArchivo('EFLOR1.000 VEL VIENTO 89M.AV.2015.07.txt');
 ProcesarArchivo('EFLOR1.000 VEL VIENTO 89M.AV.2015.08.txt');
ProcesarArchivo('EFLOR1.000 VEL VIENTO 89M.AV.2015.09.txt');
ProcesarArchivo('EFLOR1.000 VEL VIENTO 89M.AV.2015.10.txt');
ProcesarArchivo('EFLOR1.000 VEL VIENTO 91M.AV.2015.01.txt');
ProcesarArchivo('EFLOR1.000 VEL VIENTO 91M.AV.2015.02.txt');
ProcesarArchivo('EFLOR1.000 VEL VIENTO 91M.AV.2015.03.txt');
ProcesarArchivo('EFLOR1.000 VEL VIENTO 91M.AV.2015.04.txt');
ProcesarArchivo('EFLOR1.000 VEL VIENTO 91M.AV.2015.05.txt');
ProcesarArchivo('EFLOR1.000 VEL VIENTO 91M.AV.2015.06.txt');
ProcesarArchivo('EFLOR1.000 VEL VIENTO 91M.AV.2015.07.txt');
ProcesarArchivo('EFLOR1.000 VEL VIENTO 91M.AV.2015.08.txt');
ProcesarArchivo('EFLOR1.000 VEL VIENTO 91M.AV.2015.09.txt');
ProcesarArchivo('EFLOR1.000 VEL VIENTO 91M.AV.2015.10.txt');
ProcesarArchivo('EFLOR1.030 GEN TOT MED P.AV.2015.01.txt');
ProcesarArchivo('EFLOR1.030 GEN TOT MED P.AV.2015.02.txt');
ProcesarArchivo('EFLOR1.030 GEN TOT MED P.AV.2015.03.txt');
ProcesarArchivo('EFLOR1.030 GEN TOT MED P.AV.2015.04.txt');
ProcesarArchivo('EFLOR1.030 GEN TOT MED P.AV.2015.05.txt');
ProcesarArchivo('EFLOR1.030 GEN TOT MED P.AV.2015.06.txt');
ProcesarArchivo('EFLOR1.030 GEN TOT MED P.AV.2015.07.txt');
ProcesarArchivo('EFLOR1.030 GEN TOT MED P.AV.2015.08.txt');
ProcesarArchivo('EFLOR1.030 GEN TOT MED P.AV.2015.09.txt');
ProcesarArchivo('EFLOR1.030 GEN TOT MED P.AV.2015.10.txt');

cierroSerie;
cierroActor;
end;

end.

