unit uGrillasParaEditor;

{$mode delphi}

interface

uses
  Classes, SysUtils, Forms, Controls, Dialogs, Graphics, ucosa, uFormularioBase,
  uStringGridWithControls,
  uRegistroDeEditores;

type

  { TGrillaParaEditor }

  // Este tipo de grilla solo lleva BitBtns en la ultima columna
  TGrillaParaEditor=class(TStringGridWithControls)
  public

    DataSet: TDataStore;
    DataRowList: TList;

    constructor Create (AOwner: TComponent; AParent:TWinControl; AName: string;
      ds: TDataStore);

    function GetDataRow(kRow: Integer):TDataVRowOfCosa;

    procedure Refresh(vdt: TDataVTableOfCosa);

    procedure ClearAll; override;

  end;


implementation

uses
  uFormularioAutomatico;


{ TGrillaParaEditor }

constructor TGrillaParaEditor.Create(AOwner: TComponent; AParent: TWinControl;
  AName: string; ds: TDataStore);
var
  i: Integer;
  dcl: TDataColumnListOfCosa;
  dc: TDataColumnOfCosa;
begin

  inherited Create(AOwner, AParent, AName);
  self.DataSet:=ds;
  self.DataRowList:=TList.Create;

end;


{ TGrillaParaEditor }

function TGrillaParaEditor.GetDataRow(kRow: Integer): TDataVRowOfCosa;
begin
  if (kRow<=DataRowList.Count) then
    Result := DataRowList.Items[kRow-1]
  else
    Result:=nil;
end;

procedure TGrillaParaEditor.Refresh(vdt: TDataVTableOfCosa);
var
  dt: TDataTableOfCosa;
  i,j: Integer;
  DataRow: TDataRowOfCosa;
  Values: TStrings;
begin
  self.ClearAll;
  dt:=DataSet.View(vdt);

  for i:=0 to dt.DataRowListCount-1 do
  begin
    DataRow:= dt.DataRowList[i];
    Values:=DataRow.ToString();
    InsertRow(Values);

    self.DataRowList.Add(DataRow);
  end;

  self.AutoSizeColumns;
end;

procedure TGrillaParaEditor.ClearAll;
var
  i: Integer;
begin

  writeln('DataRowList.Count ',DataRowList.Count);
  for i:=1 to DataRowList.Count-1 do
    if Assigned(GetDataRow(i)) then
      GetDataRow(i).Free();

  DataRowList.Clear;

  inherited ClearAll;

end;

end.

