unit uEjemplo1;

{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, xmatdefs, matreal, Math, uproblema, ufxgx, uresfxgx;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    eLambda: TEdit;
    Label1: TLabel;
    PaintBox1: TPaintBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }

    procedure punto(X: TVectR; color: TColor);
    procedure flecha_Pv(P, v: TVectR; color: TColor);
    procedure flecha_AB(A, B: TVectR; color: TColor);
  end;


  TProblema_ej1 = class(TProblema_m01)
    function Monitor(const X, Xs: TVectR; f, fs: NReal; paso_ok: boolean): boolean;
      override;
  end;



var
  Form1: TForm1;
  c: TCanvas;
  dx, dy: integer;
  x0, y0: integer;
  m: integer;
  X, Lambda: TVectR;
  problema: TProblema_ej1;


implementation

{$R *.lfm}

type

  T_fobjetivo = class(Tfx)
    function f(const X: TVectR): NReal; override;
    procedure acum_g(var grad: TVectR; const X: TVectR); override;
  end;

  // restricción de igualdad
  T_h = class(Tfx)
    function f(const X: TVectR): NReal; override;
    procedure acum_g(var grad: TVectR; const X: TVectR); override;
  end;

  T_r = class(Tfx)
    function f(const X: TVectR): NReal; override;
    procedure acum_g(var grad: TVectR; const X: TVectR); override;
  end;


function T_fobjetivo.f(const X: TVectR): NReal;
begin
  Result := sqr(x.e(1) - 5) + sqr(x.e(2) - 5);
end;


procedure T_fobjetivo.acum_g(var grad: TVectR; const X: TVectR);
begin
  grad.acum_e(1, 2 * (x.e(1) - 5));
  grad.acum_e(2, 2 * (x.e(2) - 5));
end;


function T_h.f(const X: TVectR): NReal;
begin
  Result := sqr(x.e(1)) + sqr(x.e(2)) - 16.0;
end;


procedure T_h.acum_g(var grad: TVectR; const X: TVectR);
begin
  grad.acum_e(1, 2 * x.e(1));
  grad.acum_e(2, 2 * x.e(2));
end;



function T_r.f(const X: TVectR): NReal;
begin
  Result := x.e(1);
end;

procedure T_r.acum_g(var grad: TVectR; const X: TVectR);
begin
  grad.acum_e(1, 1);
  grad.acum_e(2, 0);
end;



{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  k: integer;
  aR: TResfx;
begin
  X := TVectR.Create_Init(2);
  Lambda := TVectR.Create_Init(2);

  randSeed := 31;

  X.pon_e(1, (20 * random - 10) / 2);
  X.pon_e(2, (20 * random - 10) / 2);

  problema := TProblema_ej1.Create_init(3, 3, 0, nil, nil);
  problema.f := T_fobjetivo.Create;

  problema.cota_inf_set(1, -10);
  problema.cota_sup_set(1, 10);
  problema.cota_inf_set(2, -10);
  problema.cota_sup_set(2, 10);

  aR := problema.restricciones[0];
  aR.tipo := TR_Igualdad;
  aR.fx := T_h.Create;
  problema.FijarRestriccionIgualdad(1);


  aR := problema.restricciones[1];
  aR.tipo := TR_Menor;
  aR.fx := T_r.Create;



  aR := Problema.restricciones[0];
  aR.lambda := 0;

  aR := Problema.restricciones[1];
  aR.lambda := StrToFloat(eLambda.Text);

  // Esto empieza por ENCAJOR X y luego calcula las restricciones
  // violadas y en base a sus gradientes calcula los Lambdas.
  Problema.EstimarMultiplicadores(X, 2);

  dx := PaintBox1.Width;
  dy := PaintBox1.Height;
  c := PaintBox1.Canvas;
  x0 := dx div 2;
  y0 := dy div 2;
  m := 50;

  c.MoveTo(x0, dy);
  c.LineTo(x0, 0);
  c.LineTo(x0 - 5, 10);
  c.LineTo(x0 + 5, 10);
  c.LineTo(x0, 0);


  c.MoveTo(0, y0);
  c.LineTo(dx, y0);
  c.LineTo(dx - 10, y0 - 5);
  c.LineTo(dx - 10, y0 + 5);
  c.LineTo(dx, y0);

  c.Brush.Color := clActiveBorder;
  c.Brush.Style := bsFDiagonal;
  c.Rectangle(x0, 0, dx, dy);

  c.Brush.Color := clBlack;
  c.Brush.Style := bsClear;

  c.EllipseC(x0, y0, m * 4, m * 4);

  c.Pen.Color := clBlue;
  for k := 1 to 10 do
    c.EllipseC(x0 + 5 * m, y0 - 5 * m, m * k, m * k);


  punto(X, clRed);

end;


procedure TForm1.flecha_Pv(P, v: TVectR; color: TColor);
var
  x, y: integer;
  x_, y_: integer;
  dx, dy: integer;
  dx_, dy_: integer;
  a: NREal;
begin
  c.Pen.Color := color;

  x := round(x0 + m * P.e(1));
  y := round(y0 - m * P.e(2));
  c.MoveTo(x, y);

  dx := round(m * v.e(1));
  dy := round(-m * v.e(2));
  x := x + dx;
  y := y + dy;
  c.LineTo(x, y);

  a := sqrt(sqr(dx) + sqr(dy));
  if (a > 1E-12) then
  begin
    dx := round(10 * dx / a);
    dy := round(10 * dy / a);
  end
  else
  begin
    dx := 0;
    dy := 0;
  end;

  dx_ := -round(dy / 2.0);
  dy_ := round(dx / 2.0);

  x_ := x - dx;
  y_ := y - dy;
  x_ := x_ + dx_;
  y_ := y_ + dy_;
  c.LineTo(x_, y_);

  x_ := x_ - 2 * dx_;
  y_ := y_ - 2 * dy_;
  c.LineTo(x_, y_);

  c.LineTo(x, y);

end;

procedure TForm1.flecha_AB(A, B: TVectR; color: TColor);
var
  v: TVectR;
begin
  v := TVectR.Create_init(2);
  v.Igual(B);
  v.sumRPV(-1.0, A);
  flecha_Pv(A, v, color);
  v.Free;
end;



procedure TForm1.punto(X: TVectR; color: TColor);
begin
  c.Pen.Color := Color;
  c.EllipseC(round(x0 + m * x.e(1)), round(y0 - m * x.e(2)), 4, 4);
end;

function TProblema_ej1.Monitor(const X, Xs: TVectR; f, fs: NReal;
  paso_ok: boolean): boolean;
begin

  inherited Monitor(X, Xs, f, fs, paso_ok);

  if paso_ok then
    Form1.flecha_AB(X, Xs, clRed)
  else
    Form1.flecha_AB(X, Xs, clBlack);
  Result := False;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  cnt_iters: integer;
  f: NReal;
  convergio: boolean;
  aR: TResfx;
  k: integer;
begin

  Problema.MaxInBox_Dual(Lambda, X, 1, 1E-20, 1000, cnt_iters, f, convergio, True);

  if convergio then
    writeln('CONVERGIO')
  else
    writeln('NO-CONVERGIO');

  writeln('cnt_iters: ', cnt_iters);
  Write('f: ', problema.f.f(X));

  Write('X: ');
  for k := 1 to X.n do
    Write(', ', x.e(k): 12: 3);
  writeln;

  for k := 0 to high(problema.restricciones) do
  begin
    aR := problema.restricciones[k];
    writeln('r_', k + 1, ': ', aR.eval_f(X): 12: 3);
  end;


  Write('Lambda: ');
  for k := 1 to Lambda.n do
    Write(', ', Lambda.e(k): 12: 3);
  writeln;

end;

end.

